aboutsummaryrefslogtreecommitdiff
path: root/test/T392-python-cffi-notmuch.sh
diff options
context:
space:
mode:
authorDavid Bremner <david@tethera.net>2022-02-15 20:53:12 -0400
committerDavid Bremner <david@tethera.net>2022-02-15 20:54:56 -0400
commitf1b2ab70c39cacb53c0b3c1d49358260a8d1818d (patch)
tree8b06d207475c256081a10ec5eb1fbd7c959610e0 /test/T392-python-cffi-notmuch.sh
parentcf342d7302544532a1f66fd7a1cc42df99fcd228 (diff)
parent7b5921877e748338359a25dae578771f768183af (diff)
Merge tag '0.35' into debian/bullseye-backportsdebian/0.35-1_bpo11+1archive/debian/0.35-1_bpo11+1
notmuch 0.35 release
Diffstat (limited to 'test/T392-python-cffi-notmuch.sh')
-rwxr-xr-xtest/T392-python-cffi-notmuch.sh48
1 files changed, 48 insertions, 0 deletions
diff --git a/test/T392-python-cffi-notmuch.sh b/test/T392-python-cffi-notmuch.sh
new file mode 100755
index 00000000..15c8fc6b
--- /dev/null
+++ b/test/T392-python-cffi-notmuch.sh
@@ -0,0 +1,48 @@
+#!/usr/bin/env bash
+test_description="python bindings (notmuch test suite)"
+. $(dirname "$0")/test-lib.sh || exit 1
+
+if [ $NOTMUCH_HAVE_PYTHON3_CFFI -eq 0 -o $NOTMUCH_HAVE_PYTHON3_PYTEST -eq 0 ]; then
+ test_done
+fi
+
+add_email_corpus
+
+cat <<EOF > recurse.py
+from notmuch2 import Database
+def show_msgs(msgs, level):
+ print('{:s} {:s}'.format(' ' * level*4, type(msgs).__name__))
+ for msg in msgs:
+ print('{:s} {:s}'.format(' ' * (level*4+2), type(msg).__name__))
+ replies=msg.replies()
+ show_msgs(replies, level+1)
+db = Database(config=Database.CONFIG.SEARCH)
+msg=db.find("87ocn0qh6d.fsf@yoom.home.cworth.org")
+threads = db.threads(query="thread:"+msg.threadid)
+thread = next (threads)
+show_msgs(thread, 0)
+EOF
+
+test_begin_subtest "recursive traversal of replies (no crash)"
+test_python < recurse.py
+error=$?
+test_expect_equal "${error}" 0
+
+test_begin_subtest "recursive traversal of replies (output)"
+test_python < recurse.py
+tail -n 10 < OUTPUT > OUTPUT.sample
+cat <<EOF > EXPECTED
+ OwnedMessage
+ MessageIter
+ OwnedMessage
+ MessageIter
+ OwnedMessage
+ MessageIter
+ OwnedMessage
+ MessageIter
+ OwnedMessage
+ MessageIter
+EOF
+test_expect_equal_file EXPECTED OUTPUT.sample
+
+test_done